import 'dart:convert';
import 'dart:isolate';

import 'package:tankobon_lib/src/classes/manga.dart';
import 'package:tankobon_lib/src/classes/manga_title.dart';

Future<List<Manga>> fetchMangaList({required String source, int offset = 0, String? search}) async {
  final port = ReceivePort();
  return Isolate.spawnUri(
    Uri.dataFromString(
      source,
      mimeType: 'application/dart',
    ),
    ['mangaList', '$offset', search ?? ''],
    port.sendPort,
    onError: port.sendPort,
  ).then(
    (value) async =>
        [...json.decode(await port.first as String).map((dynamic e) => Manga.fromJson(e as Map<String, dynamic>))],
  );
}

Future<MangaTitle>? fetchMangaById({required String source, required String id}) async {
  final port = ReceivePort();
  return Isolate.spawnUri(
    Uri.dataFromString(
      source,
      mimeType: 'application/dart',
    ),
    ['mangaList', id],
    port.sendPort,
    onError: port.sendPort,
  ).then(
    (value) async => MangaTitle.fromJson(await port.first as Map<String, dynamic>),
  );
}
